'--------------------------------------------------------------
'                 (c) 2006 - j.p.
'--------------------------------------------------------------
' file: Potencjometr / Listing2.BAS ver. 1.0 15-05-2006
'--------------------------------------------------------------
' Sterowanie potencjometrem obrotowym z silnikiem elektr.

$crystal = 16000000
$regfile = "89c2051.DAT"

Dim Keyb As Byte                                              ' biezacy stan klawiatury
Dim Keyp As Byte                                              ' poprzedni stan klawiatury
Dim Timelock As Byte                                          ' opoznienie do bezpiecznika pradowego
Dim Motor_on As Bit                                           ' =1 gdy silnik pracuje
Config Timer0 = Timer , Gate = Internal , Mode = 1
      ' Mode = 1 : 16-bit timer
      ' Dla 16 MHz jest INT co 49.152 ms tj. ok.20 razy na sekunde
On Timer0 Timer_0_int
      'Inicjowanie zmiennych:
Keyb = 255
Keyp = 255
Timelock = 0
Reset Motor_on
Priority Set Timer0
Enable Timer0
Enable Interrupts
Start Timer0

      ' Ptla glwna programu
Mainloop:
      ' Obsluga klawiatury:
P1 = P1 Or &B11110000
Keyb = P1                                                     ' Odczyt stanu klawiatury
Keyb = Keyb Or &B00001111
If Keyb <> Keyp Then
   Keyp = Keyb
Else                                                          ' Keyp=Keyb tj.potwierdzony klawisz
   Select Case Keyb
     Case &B11111111:                                         ' Nie wcisniety zaden klawisz
       P1 = P1 Or &B00001100
       Reset Motor_on
       Timelock = 0
     Case &B11101111:                                         ' Klawisz K1
      If Motor_on = 0 And Timelock = 0 Then
         Set Motor_on
         P1.2 = 0
         Timelock = 6                                         ' Opoznienie ok. 300 ms
      End If
      If Motor_on = 1 And P1.3 = 0 Then                       ' Przeciwne obroty
         P1 = P1 Or &B00001100
         Reset Motor_on
         Timelock = 10                                        ' Opoznienie 1 s zmiany kierunku
      End If
     Case &B11011111:                                         ' Klawisz K2
      If Motor_on = 0 And Timelock = 0 Then
         Set Motor_on
         P1.3 = 0
         Timelock = 6
      End If
      If Motor_on = 1 And P1.2 = 0 Then
         P1 = P1 Or &B00001100
          Reset Motor_on
          Timelock = 10
      End If
     Case &B11001111:                                         ' Klawisze K1 i K2 jednoczesnie
       P1 = P1 Or &B00001100
       Reset Motor_on
   End Select
End If
P3.7 = 1                                                      ' Sterowanie LED
If Motor_on = 1 Then P3.7 = 0
      ' Bezpiecznik pradowy
If Motor_on = 1 And Timelock = 0 Then
   If P3.6 = 1 Then
       P1 = P1 Or &B00001100
       Reset Motor_on
       Timelock = 40                                          'Blokada startu silnika na 2 sek.
   End If
End If

Idle                                                          ' stan uspienia
Goto Mainloop

End

Timer_0_int:
If Timelock <> 0 Then
   Decr Timelock
End If
Return